#define NO_EXIT_SUPPORT
#define OPTIMIZE_ROM_CALLS

#define NO_CALC_DETECT
#define MIN_AMS 100

#include <tigcclib.h>
#include "../../lib/extgraph.h" // NOTE: this path is just for this demo !!
//#include "extgraph.h" // NOTE: this path is just for this demo !!
                                  //       if the extgraph library is correctly
                                  //       installed you should use:
                                  //
                                  //       #include <extgraph.h>

void _main(void) {
    LCD_BUFFER backbuffer;
    unsigned short buffer[(4*100+6)*20/2]; // Warning, large.
    unsigned short i,j,k;

    LCD_save(backbuffer);

    ST_helpMsg("Sprite8Get() Demo - Press Key");
    ngetchx();

    for (k=0;k<6;k++) {
        for (j=0;j<80;j++) {
            for (i=0;i<20;i++) {
                Sprite8Get_R(j+(i<<3),k,100-k,backbuffer,(unsigned char *)buffer+100*i);
            }
            ClrScr();
            for (i=0;i<20;i++) {
                Sprite8_RPLC_R(j+(i<<3),k,100-k,(unsigned char *)buffer+100*i,LCD_MEM);
            }
        }
    }

    ST_helpMsg("FastGet/PutBkgrnd8() Demo - Press Key");
    ngetchx();

    for (k=0;k<6;k++) {
        for (j=0;j<80;j++) {
            for (i=0;i<20;i++) {
                FastGetBkgrnd8_R(j+(i<<3),k,100-k,backbuffer,buffer+203*i);
            }
            ClrScr();
            for (i=0;i<20;i++) {
                FastPutBkgrnd8_R(buffer+203*i,LCD_MEM);
            }
        }
    }

    ST_helpMsg("Sprite16Get() Demo - Press Key");
    ngetchx();

    for (k=0;k<6;k++) {
        for (j=0;j<80;j++) {
            for (i=0;i<10;i++) {
                Sprite16Get_R(j+(i<<4),k,100-k,backbuffer,(unsigned short *)buffer+100*i);
            }
            ClrScr();
            for (i=0;i<10;i++) {
                Sprite16_RPLC_R(j+(i<<4),k,100-k,(unsigned short *)buffer+100*i,LCD_MEM);
            }
        }
    }

    ST_helpMsg("FastGet/PutBkgrnd16() Demo - Press Key");
    ngetchx();

    for (k=0;k<6;k++) {
        for (j=0;j<80;j++) {
            for (i=0;i<10;i++) {
                FastGetBkgrnd16_R(j+(i<<4),k,100-k,backbuffer,buffer+203*i);
            }
            ClrScr();
            for (i=0;i<10;i++) {
                FastPutBkgrnd16_R(buffer+203*i,LCD_MEM);
            }
        }
    }

    LCD_restore(backbuffer);
    GKeyFlush();
    ST_helpMsg(EXTGRAPH_VERSION_PWDSTR);
}
